/*
šňůrka:
kuličky prumer 3mm
rozchod kulicek 4.2mm
*/


BSpac=4.2;   // rozestup kuliček
BDiam=3.2;  // velikost kuliček + rezerva
WDiam=1;   // tloušťka šňůrky
BNum=5;   // počet kuliček

LockAngle=10; // úhel zámku
LockDepth=4; // hloubka zámku

$fn=40;


all();


module all() {
  difference() {
    base ();
      translate([2,-4,-BNum/2*BSpac]){
         wireDiff();
        %wireDiff();
      }
      translate([2,4,-BNum/2*BSpac]){
         wireDiff();
        %wireDiff();    
      }
      translate([0,0,12])
        hole();
      translate([0,0,-12])
        hole();
      }
}


module base () {
 rotate ([0,90,0]) {
   hull(){
    translate ([17,8,-3])
        subbaseA();
    translate ([-17,8,-3]) 
        subbaseA();
    translate ([17,-8,-3]) 
        subbaseA();
    translate ([-17,-8,-3]) 
        subbaseA();
    }
 }
 rotate ([0,90,0]) {
   hull(){
    translate ([4.5,6,0])
       subbase();
    translate ([-4.5,6,0]) 
       subbase();
    translate ([4.5,-6,0]) 
       subbase();
    translate ([-4.5,-6,0]) 
       subbase();
    }
 }
}

module subbaseA(){
    cylinder (d=2, h=2);
   translate ([0,0,2]) 
    sphere (d=2);
}

module subbase(){
    cylinder (d=4, h=3);
   translate ([0,0,3]) 
    sphere (d=4);
}
 
module hole (){
    rotate ([0,90,0]) {
        cylinder (d=3.3, h=10, center=true);
      translate ([0,0,-2]){
        cylinder (d1=3, d2=6, h=2);
      }
//      translate ([0,0,-3]){
//        cylinder (d1=6, d2=3, h=.5);
//      }
    }
}

module wireDiff()
{
  hull(){
   translate([0,0,-BSpac*BNum/2]){
      cylinder(d=WDiam, h=BSpac*BNum*2);
       }
   translate([LockDepth,0,-BSpac*BNum/2]){
      cylinder(d=WDiam, h=BSpac*BNum*2);
       }
  }
  for (item=[0:BNum-1])
   hull()
   {
    translate([LockDepth,0,BSpac/2+BSpac*item-LockDepth*tan(LockAngle)]){
        sphere(d=BDiam);}
    translate([0,0,BSpac/2+BSpac*item]){
        sphere(d=BDiam);}
   }
}